import uuid
import logging

from logging import Logger

from . import ios


def __init__(params: dict) -> Logger:
    logger = Logger(uuid.uuid4().hex[20:], params['level'])
    formatter = logging.Formatter(params['logfmt'], params['datefmt'])

    if 'stream' in params['output']:
        handler = logging.StreamHandler()
        handler.setFormatter(formatter)
        logger.addHandler(handler)

    if 'file' in params['output']:
        ios.genpath(ios.dirname(params['handler']))
        handler = logging.FileHandler(params['handler'], encoding='UTF-8')
        handler.setFormatter(formatter)
        logger.addHandler(handler)

    return logger


def __call__(self, info, l: str = 'info'):
    getattr(self, l)(info)


Logger.__call__ = __call__

sine: Logger
simple: Logger
